<?php

namespace Drupal\realname\Plugin\Action;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Action\ActionBase;

/**
 * Adds a transaction to a cluster during validation phase.
 *
 * @Action(
 *   id = "realname_update",
 *   label = @Translation("Update the stored Realname value"),
 *   type = "user"
 * )
 */
class RealnameUpdate extends ActionBase {

  /**
   * {@inheritdoc}
   */
  public function execute() {
    $account = func_get_arg(0);
    realname_update($account);
  }

  /**
   * {@inheritdoc}
   */
  public function access($object, AccountInterface $account = NULL, $return_as_object = FALSE) {
    drupal_set_message('who can use the update realname action?');
    return $return_as_object ? AccessResult::allowed() : TRUE;
  }

}

/**
 * FROM D7.
 *
 * Implements hook_rules_action_info().
 *
 * @todo
 *
 * function realname_rules_action_info() {
 * $items['user_realname_update'] = array(
 * 'label' => t('Update real name'),
 * 'base' => 'realname_action_realname_update',
 * 'parameter' => array(
 * 'account' => array(
 * 'type' => 'user',
 * 'label' => t('User'),
 * 'save' => FALSE,
 * ),
 * ),
 * 'group' => t('User'),
 * 'access callback' => 'rules_user_integration_access',
 * );
 * return $items;
 * }
 */
