<?php

namespace Drupal\cforge\EventSubscriber;

use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpKernel\KernelEvents;
use Symfony\Component\HttpKernel\Event\GetResponseEvent;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\Routing\Exception\RouteNotFoundException;

/**
 * Cforge react to events.
 */
class CforgeSubscriber implements EventSubscriberInterface {

  /**
   * Find out what the front page is.
   */
  public function cforgeFront(GetResponseEvent $event) {
    if (\Drupal::currentUser()->isAuthenticated()) {
      if ($event->getRequest()->getpathinfo() == '/') {
        $response = new RedirectResponse(\Drupal::config('cforge.settings')->get('member_frontpage'));
        $event->setResponse($response);
      }
    }
    else {
      $path = trim($event->getRequest()->getpathinfo(), '/');
      // If there was a trailing slash filter the empty part.
      $parts = array_filter(explode('/', $path));
      if (count($parts) > 5) {
        throw new RouteNotFoundException('Access denied');
      }
    }
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    $events[KernelEvents::REQUEST][] = array('cforgeFront');
    return $events;
  }

}
